# Copyright 2020 StrongDM Inc
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from . import audits_pb2 as audits__pb2


class AuditsStub(object):
    """Audit exposes the endpoints to extract point-in-time snapshot of data.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.GetAccessRules = channel.unary_unary(
                '/v1.Audits/GetAccessRules',
                request_serializer=audits__pb2.GetAccessRulesRequest.SerializeToString,
                response_deserializer=audits__pb2.GetAccessRulesResponse.FromString,
                )


class AuditsServicer(object):
    """Audit exposes the endpoints to extract point-in-time snapshot of data.
    """

    def GetAccessRules(self, request, context):
        """GetAccessRules gets a list of Access Rules at point-in-time.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_AuditsServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'GetAccessRules': grpc.unary_unary_rpc_method_handler(
                    servicer.GetAccessRules,
                    request_deserializer=audits__pb2.GetAccessRulesRequest.FromString,
                    response_serializer=audits__pb2.GetAccessRulesResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'v1.Audits', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class Audits(object):
    """Audit exposes the endpoints to extract point-in-time snapshot of data.
    """

    @staticmethod
    def GetAccessRules(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/v1.Audits/GetAccessRules',
            audits__pb2.GetAccessRulesRequest.SerializeToString,
            audits__pb2.GetAccessRulesResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
